datablock ParticleData(Disease3Spores)
{
	dragCoefficient      = 4;
	gravityCoefficient   = 0.01;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS = 15000;
	lifetimeVarianceMS = 500;
	textureName = "base/data/particles/cloud";
	
	spinSpeed = 25.0;
	spinRandomMin = -500.0;
	spinRandomMax = 500.0;
	
	colors[0] = 33/255 SPC 158/255 SPC 11/255 SPC 0.3;
	colors[1] = 33/255 SPC 158/255 SPC 11/255 SPC 0.3;
	colors[2] = 33/255 SPC 158/255 SPC 11/255 SPC 0.3;
	sizes[0] = 5.0;
	sizes[1] = 4.0;
	sizes[2] = 3.0;
	
	useInvAlpha = true;
};

datablock ParticleEmitterData(Disease3SporeEmitter)
{
	lifeTimeMS = 50;
	
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1;
   velocityVariance = 1.0;
   ejectionOffset   = 2.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
	particles = Disease3Spores;
	
	emitterNode = HalfEmitterNode;
};

datablock ExplosionData(Disease3SporeExplosion)
{
	lifeTimeMS = 15000;

	soundProfile = "";
	
	emitter[0] = Disease3SporeEmitter;
	particleEmitter = Disease3SporeEmitter;
   particleDensity = 100;
   particleRadius = 1;
	
	faceViewer = true;
	explosionScale = "1 1 1";
	
	lightStartRadius = 0;
	lightEndRadius = 0;
	lightStartColor = "0.0 0.0 0.0";
	lightEndColor = "0 0 0";
};

//Bile
datablock ProjectileData(BileBombProjectile)
{
		projectileShapeName				= "./Models/Bilebomb/BileBombProjectile.dts";
		directDamage					= 0;
		directDamageType				= $DamageType::RocketDirect;
		radiusDamageType				= $DamageType::RocketRadius;
		
		brickExplosionRadius			= 0;
		brickExplosionImpact			= false;
		brickExplosionForce				= 0;
		brickExplosionMaxVolume			= 0;
		brickExplosionMaxVolumeFloating	= 0;
		
		impactImpulse					= 400;
		verticalImpulse					= 400;
		explosion						= "Disease3SporeExplosion";
		particleEmitter					= "";
		
		muzzleVelocity					= 25;
		velInheritFactor				= 0;
		
		armingDelay						= 0;
		lifetime						= 20000;
		fadeDelay						= 20000;
		bounceElasticity				= 0.4;
		bounceFriction					= 0.3;
		isBallistic						= true;
		gravityMod						= 1.0;
		
		hasLight						= false;
		lightRadius						= 3.0;
		lightColor						= "0 0 0.5";
		
		uiName							= "";
};

datablock ProjectileData(BileBombFakeProjectile)
{
   projectileShapeName				= "base/data/shapes/empty.dts";
   directDamage        = 0;
   directDamageType = $DamageType::RocketDirect;
   radiusDamageType = $DamageType::RocketRadius;
   //impactImpulse	   = 1000;
   //verticalImpulse	   = 1000;
   explosion           = "";
   particleEmitter     = "";
   
   explodeOnPlayerImpact = 0;
   explodeOnDeath = 1;

   brickExplosionRadius = 0;
   brickExplosionImpact = false;
   brickExplosionForce  = 0;             
   brickExplosionMaxVolume = 0;
   brickExplosionMaxVolumeFloating = 0;

   sound = "";

   muzzleVelocity      = 30;
   velInheritFactor    = 0;
   explodeOnDeath = true;

   armingDelay         = 15000; //4 second fuse 
   lifetime            = 15000;
   fadeDelay           = 13000;
   bounceElasticity    = 0.4;
   bounceFriction      = 0.5;
   isBallistic         = true;
   gravityMod = 0;

   hasLight    = false;
   lightRadius = 1.0;
   lightColor  = "0 0 0";

   uiName = "";
};

datablock ItemData(BileBombItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Models/Bilebomb/BileBombItem.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Bile Bomb";
	iconName = "./Models/Icon/icon_BileBomb";
	doColorShift = true;
	colorShiftColor = "1 1 1 1";

	 // Dynamic properties defined by the scripts
	image = BileBombImage;
	canDrop = true;
};

datablock ShapeBaseImageData(BileBombImage)
{
   // Basic Item properties
   shapeFile = "./Models/Bilebomb/BileBombItem.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "-0.025 0.05 0";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BileBombItem;
   ammo = " ";
   projectile = BileBombProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "1 1 1 1";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

  		// States
		stateName[0]					= "Activate";
		stateSequence[0]				= "ready";
		stateSound[0]					= weaponSwitchSound;
		stateTimeoutValue[0]			= 0.1;
		stateTransitionOnTimeout[0]		= "Ready";

		stateName[1]					= "Ready";
		stateAllowImageChange[1]		= true;
		stateTransitionOnTriggerDown[1]	= "Charge";

		stateName[2]					= "Charge";
		stateTimeoutValue[2]			= 0.3;
		stateTransitionOnTimeout[2]		= "Charged";
		stateTransitionOnTriggerUp[2]	= "AbortCharge";
		stateScript[2]					= "onCharge";
		stateWaitForTimeout[2]			= true;

		stateName[3]					= "Charged";
		stateAllowImageChange[3]		= false;
		stateTransitionOnTriggerUp[3]	= "Fire";

		stateName[4]					= "Fire";
		stateAllowImageChange[4]		= false;
		stateFire[4]					= true;
		stateScript[4]					= "onFire";
		stateTimeoutValue[4]			= 0.5;
		stateTransitionOnTimeout[4]		= "Done";
		stateWaitForTimeout[4]			= true;
		
		stateName[5]					= "Done";
		stateScript[5]					= "onDone";
		
		stateName[6]					= "AbortCharge";
		stateScript[6]					= "onChargeAbort";
		stateTimeoutValue[6]			= 0;
		stateTransitionOnTimeout[6]		= "Ready";
	};

function BileBombImage::onCharge(%this, %obj, %slot)
{
	%obj.playthread(2, spearReady);
	%obj.lastBileSlot = %obj.currTool;
}

function BileBombImage::onAbortCharge(%this, %obj, %slot)
{
	%obj.playthread(2, root);
}

function BileBombImage::onFire(%this, %obj, %slot)
{
	%obj.playthread(2, spearThrow);
	Parent::onFire(%this, %obj, %slot);
	
	%currSlot = %obj.lastBileSlot;
	%obj.tool[%currSlot] = 0;
	%obj.weaponCount--;
	messageClient(%obj.client,'MsgItemPickup','',%currSlot,0);
	serverCmdUnUseTool(%obj.client);
}

function BileExplosion(%this, %obj, %slot)
{
	  %pos = %this.getPosition();

	  %radius = 5;
      %searchMasks = $TypeMasks::PlayerObjectType;
      InitContainerRadiusSearch(%pos, %radius, %searchMasks);
      while ((%targetid = containerSearchNext()) != 0 )
     {
     %word = strLwr(getSubStr(%targetid.hType, 0, 6));

	  if(%word $= "zombie")
	   {
		%targetid.hType = "biled" @ getRandom(1,1000);
		%targetid.mountImage(BileStatusPlayerImage, 2);
		schedule(60000,0,BiledClear,%targetid,%obj);
		%targetid.BoomerBiled = 1;
	   }
}
}

function BileBombProjectile::onCollision(%this, %obj)
{
	%pos = %obj.getPosition();
	serverPlay3d(BileExplodeSound,%pos);
	BileExplosion(%obj);

   %p = new Projectile()
   {
      dataBlock = BileBombFakeProjectile;
      initialPosition = %pos;
      initialVelocity = "0 0 1";
      sourceObject = %obj.sourceObject;
      client = %obj.client;
      sourceSlot = 0;
      originPoint = %obj.originPoint;
   };
   if(isObject(%p))
   {
      MissionCleanup.add(%p);
      %p.setScale(%obj.getScale());
   } 
}