datablock fxDTSBrickData (BrickZombieSoldier_HoleSpawnData : BrickCZombie_HoleSpawnData)
{
	uiName = "Zombie Soldier Hole";
	iconName = "Add-Ons/Bot_Zombie_L4B2_EXT/Models/Icon/icon_soldier";
 
	holeBot = "ZombieSoldierHoleBot";
};

//Gear for mr soldier
datablock ShapeBaseImageData(gc_zBallisticVestMountedImage) {
	shapeFile = "./Models/BallisticVest.dts";
	emap = true;
	mountPoint = $HipSlot;
	offset = "0 0.03 0.63";
	eyeOffset = "0 0 10";
	rotation = eulerToMatrix("0 0 0");
	scale = "1 1 1";
	correctMuzzleVector = true;
	doColorShift = false;
	colorShiftColor = "1 1 1 1";

	isGCArmor = 1; //Custom property

	stateName[0] = "Activate";
	stateTimeoutValue[0] = 0.1;
	stateTransitionOnTimeout[0] = "Idle";

	stateName[1] = "Idle";
	stateAllowImageChange[1] = true;
};

datablock ShapeBaseImageData(gc_zBallisticHelmetMountedImage) {
	shapeFile = "./Models/BallisticHelmet.dts";
	emap = true;
	mountPoint = $HeadSlot;
	offset = "0 0 -0.015";
	eyeOffset = "0 0 10";
	rotation = eulerToMatrix("0 0 0");
	scale = "1 1 1";
	correctMuzzleVector = true;
	doColorShift = false;
	colorShiftColor = "1 1 1 1";

	isGCArmor = 1; //Custom property

	stateName[0] = "Activate";
	stateTimeoutValue[0] = 0.1;
	stateTransitionOnTimeout[0] = "Idle";

	stateName[1] = "Idle";
	stateAllowImageChange[1] = true;
};

//Bot stuff
datablock PlayerData(ZombieSoldierHoleBot : CZombieHoleBot)
{
	jumpForce = 9.5*110;

	maxdamage = 250;//Health

	hName = "Infected";//cannot contain spaces

    hAttackDamage = 10;//15;//Melee Damage
};

function ZombieSoldierHoleBot::onAdd(%this,%obj,%style)
{
	CZombieHoleBot::onAdd(%this,%obj);

	// Default Style Clothing
	if( !$L4B2Bots::CustomStyle )
	{
		// colors
		%randskin[ %nrandskin = 0 ] = "0.55 0.55 0.55 1";
		%randskin[ %nrandskin++ ] = "0.7 0.7 0.7 1";
		%randskin[ %nrandskin++ ] = "0.3 0.3 0.3 1";
		
		%randskin = %randskin[ getRandom( 0, %nrandskin ) ];

		%skinColor = %randskin;// getRandomBotColor();
		%handColor = %skinColor;

		%uniformColor = "0.0909091 0.181818 0.0909091 1";
		
		%decal = "AAA-None";
		
		%hat = 0;
		
		%pack = 0;
		%pack2 = 0;
		%accent = 0;
		%face = "asciiTerror";
	}

	if( $L4B2Bots::CustomStyle )
	{
		%skinColor = "0.623 0.686 0.529 1";// getRandomBotColor();
		%handColor = %skinColor;

		%uniformColor = "0.0909091 0.181818 0.0909091 1";
		
		%decal = "AAA-None";
		
		%hat = 0;
		
		%pack = 0;
		%pack2 = 0;
		%accent = 0;

		// Face
		%face[ %nFace = 0 ] = "ZombieFaceA";
		%face[ %nFace++ ] = "ZombieFaceB";
		%face[ %nFace++ ] = "ZombieFaceC";
		%face[ %nFace++ ] = "ZombieFaceD";
		%face[ %nFace++ ] = "ZombieFaceE";
		%face[ %nFace++ ] = "ZombieFaceF";
		%face[ %nFace++ ] = "ZombieFaceG";
		%face[ %nFace++ ] = "ZombieFaceI";
		
		%face = %face[ getRandom( 0, %nFace ) ];
	}

	armor::onAdd(%this,%obj);
	//Appearance zombie
	%obj.llegColor =  %uniformColor;
	%obj.secondPackColor =  "0 0.435 0.831 1";
	%obj.lhand =  "0";
	%obj.hip =  "0";
	%obj.faceName =  %face;
	%obj.rarmColor =  %uniformColor;
	%obj.hatColor =  "1 1 1 1";
	%obj.hipColor =  %uniformColor;
	%obj.chest =  getRandom(0,1);
	%obj.rarm =  "0";
	%obj.packColor =  "0.2 0 0.8 1";
	%obj.pack =  "0";
	%obj.decalName =  %decal;
	%obj.larmColor =  %uniformColor;
	%obj.secondPack =  "0";
	%obj.larm =  "0";
	%obj.chestColor =  %uniformColor;
	%obj.accentColor =  "0.990 0.960 0 0.700";
	%obj.rhandColor =  %skinColor;
	%obj.rleg =  "0";
	%obj.rlegColor =  %uniformColor;
	%obj.accent =  "1";
	%obj.headColor =  %skinColor;
	%obj.rhand =  "0";
	%obj.lleg =  "0";
	%obj.lhandColor =  %skinColor;
	%obj.hat =  "0";

GameConnection::ApplyBodyParts(%obj);
GameConnection::ApplyBodyColors(%obj);
%obj.mountImage(gc_zBallisticVestMountedImage, 0);
%obj.hideNode("armor");
%obj.mountImage(gc_zBallisticHelmetMountedImage, 1);
%obj.hideNode("hat");
	
	%obj.hCanDistract = 0;

}

function ZombieSoldierHoleBot::onBotLoop(%this,%obj)
{
	CZombieHoleBot::onBotLoop(%this,%obj);
}

function ZombieSoldierHoleBot::onBotFollow( %this, %obj, %targ )
{

	CZombieHoleBot::onBotFollow(%this,%obj,%targ);
}

function ZombieSoldierHoleBot::onCollision(%this, %obj, %col, %fade, %pos, %norm)
{
	CZombieHoleBot::onCollision(%this, %obj, %col, %fade, %pos, %norm);
}

function ZombieSoldierHoleBot::onDamage(%this,%obj)
{
	%obj.playaudio(2,"KevlarHit" @ getrandom(1,3));

	CZombieHoleBot::OnDamage(%this,%obj);
}