//Base Blockhead guy
if(LoadRequiredAddOn("Bot_Zombie_L4B2") == $Error::None)
{
	if(LoadRequiredAddOn("Event_botSpawnLoot") == $Error::None)
	{
	exec("./bot_zombie_soldier.cs");
	exec("./bot_zombie_toxic.cs");
	exec("./bot_zombie_slow.cs");
	exec("./bot_zombie_fast.cs");
	exec("./bot_zombie_hazmat.cs");
	exec("./bot_zombie_construction.cs");
	exec("./bot_zombie_fallen.cs");
	exec("./sounds.cs");
	}
}

%errorA = forceRequiredAddOn("Sound_Phone");
%errorB = forceRequiredAddOn("Projectile_GravityRocket");

if(%errorA == $Error::AddOn_NotFound)
{
   error("ERROR: Bot_Zombie_L4B2_EXT - required add-on Sound_Phone not found");
}
else if(%errorB == $Error::AddOn_NotFound)
{
   error("ERROR: Bot_Zombie_L4B2_EXT - required add-on Projectile_GravityRocket not found");
}
else
{
   exec("./Weapon_PipeBomb.cs");
   exec("./Item_BileBomb.cs");
}

package ProjectileAdds
{
   function Projectile::onAdd(%obj,%a,%b)
   {
      Parent::onAdd(%obj,%a,%b);
      if(%obj.dataBlock.getID() == sPipeBombProjectile.getID())
      {
         %obj.schedule(500,spawnPipeFlash,0);
         %obj.schedule(750,ZombieDistract,0);
      }

      if(isObject(flareGunProjectile))//This is for the SWeps flare gun projectile
      {
      if(%obj.dataBlock.getID() == flareGunProjectile.getID())
      {
         %obj.schedule(500,ZombieDistract,0);
      }
  	  }

      if(%obj.dataBlock.getID() == BileBombFakeProjectile.getID())
      {
         %obj.schedule(0,ZombieDistract,0);
      }
   }
};activatePackage(ProjectileAdds);

package SWepFlamesBurnsZombs
{

function player::flamer_burnStart(%pl,%tick)
{
	if(!%pl.getDatablock().noBurning)
	{
	if(!%pl.isBurning)
	{
		%pl.setTempColor("0.1 0.1 0.1 1");
		%pl.flamer_burn(%tick);
		%pl.flamerBurnTickAdd = 0;
	}
	else
	{
		%pl.flamerBurnTickAdd = %tick;
	}
	}
}

function player::flamer_burn(%pl,%tick)
{
	%word = strLwr(getSubStr(%pl.hType, 0, 5));

	if(%pl.hType $= "Zombie" || %word $= "biled")
	{
		cancel(%pl.flamerClearBurnSched);
		%pl.isBurning = 1; 

		cancel(%pl.burnSched);
		if(!isObject(%pl.getMountedImage(3)))
		{
			%pl.mountImage(flamerFleshBurningImage,3);
		}
		if(!%pl.isPlayingBurningSound)
		{
			%pl.playAudio(3,fleshFireLoopSound);
			%pl.isPlayingBurningSound = 1;
		}
		
		%dmg = 4;
		if(%pl.isCrouched())
			%dmg *= 0.47619;
		if(%pl.getDamagePercent() < 1)
		{
			%pl.damage(%pl.lastFireAttacker,%pl.getPosition(),%dmg,%pl.lastBurnDmgType);
			if(%pl.hCommonZombie)
			{
				%pl.hRunAwayFromPlayer(%pl);
				%pl.stopHoleLoop();
			}
			%pl.playThread(2,plant);
		}
	
		%pl.burnSched = %pl.schedule(500,flamer_burn,%tick);
	}
	else
	{
			cancel(%pl.flamerClearBurnSched);
	%pl.isBurning = 1;
	if(%pl.flamerBurnTickAdd > 0 && %pl.flamerBurnTickAdd > %tick)
	{
		%tick = mFloor(%pl.flamerBurnTickAdd);
		%pl.flamerBurnTickAdd = 0;
	}
	cancel(%pl.burnSched);
	if(!isObject(%pl.getMountedImage(3)))
	{
		%pl.mountImage(flamerFleshBurningImage,3);
	}
	if(!%pl.isPlayingBurningSound)
	{
		%pl.playAudio(3,fleshFireLoopSound);
		%pl.isPlayingBurningSound = 1;
	}
	
	%dmg = mClamp(%tick,3,6)*1.75;
	if(%pl.isCrouched())
		%dmg *= 0.47619;
	if(%pl.getDamagePercent() < 1)
	{
		%pl.damage(%pl.lastFireAttacker,%pl.getPosition(),%dmg,%pl.lastBurnDmgType);
		%pl.playThread(2,plant);
	}
	
	if(%tick <= 0)
	{
		%pl.unMountImage(3);
		%pl.isBurning = 0;
		%pl.playAudio(3,napalmFireEndSound);
		%pl.isPlayingBurningSound = 0;
		if(%pl.getDamagePercent() < 1)
		{
			%pl.flamerClearBurnSched = %pl.schedule(1500,flamer_clearBurn);
		}
		return;
	}
	%pl.burnSched = %pl.schedule(500,flamer_burn,%tick--);
	}
}

function molotov_explode(%pos,%obj,%cl)
{
	%mask = $TypeMasks::PlayerObjectType;
	%max = 6;
	initContainerRadiusSearch(%pos,%max,%mask);
	while(%pl = containerSearchNext())
	{
		if(isObject(%pl.client) && !isObject(%pl.client.minigame))
			continue;
		if(%pl.getDatablock().noBurning)
			continue;
		if(minigameCanDamage(%obj,%pl) != 1)
			continue;
		%dist = vectorDist(%pl.getPosition(),%pos);
		%dmg = (%p=(1-(%dist/%max)))*40;
		if(%p > 0.2)
		{
			%pl.lastBurnDmgType = $DamageType::Molotov;
			%pl.lastFireAttacker = %proj.client;
			%pl.flamer_burnStart(mCeil(%p*8));
		}
		%pl.damage(%obj.client,%pl.getPosition(),%dmg,$DamageType::Molotov);
	}
	serverPlay3D(molotovExplosionSound,%pos);

			for (%n = 0; %n < 5; %n++)
		{
    		schedule(3500 * %n, 0, createFireCircle, %pos,30,40,%cl,%obj,$DamageType::Molotov);
		}
}

function flamerProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
	%damageType = $DamageType::Flamer;
	%scale = getWord(%obj.getScale(), 2);
    %directDamage = mClampF(%this.directDamage, -100, 100) * %scale;

   if(%col.getType() & $TypeMasks::PlayerObjectType)
   {
   	if(!%col.getDatablock().noBurning)
   	{
      %col.damage(%obj, %pos, %directDamage, %damageType);
   	}
   }
}

function molotovProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
	%damageType = $DamageType::Flamer;
	%scale = getWord(%obj.getScale(), 2);
    %directDamage = mClampF(%this.directDamage, -100, 100) * %scale;

   if(%col.getType() & $TypeMasks::PlayerObjectType)
   {
   	if(!%col.getDatablock().noBurning)
   	{
      %col.damage(%obj, %pos, %directDamage, %damageType);
   	}
   }
}
};

if($AddOn__Weapon_SWeps_Ext $= "1")
{
	activatePackage(SWepFlamesBurnsZombs);
}

package FlareGunBurnsZombs
{
function flareGunProjectile::onCollision(%db,%proj,%hit,%fade,%pos,%normal)
{	
	%word = strLwr(getSubStr(%hit.hType, 0, 5));

	if(%hit.hType $= "Zombie" || %word $= "biled")
	{
	%hit.flamer_burnStart(4);
	}
	parent::onCollision(%db,%proj,%hit,%fade,%pos,%normal);
}
};

if($AddOn__Weapon_SWeps_FlareGun $= "1" && $AddOn__Weapon_SWeps_Ext $= "1")
{
	activatePackage(FlareGunBurnsZombs);
}